Index: irmp.c
===================================================================
--- irmp.c	(Revision 191)
+++ irmp.c	(Arbeitskopie)
@@ -4987,45 +5014,45 @@ irmp_ISR (void)
 #endif // ANALYZE
                                     irmp_store_bit (0);
                                     last_value = 0;
-                                    wait_for_space = 0;
+                                    ir->isr.wait_for_space = 0;
                                 }
-                                else if (irmp_pause_time >= BANG_OLUFSEN_R_PAUSE_LEN_MIN && irmp_pause_time <= BANG_OLUFSEN_R_PAUSE_LEN_MAX)
+                                else if (ir->isr.pause_time >= BANG_OLUFSEN_R_PAUSE_LEN_MIN && ir->isr.pause_time <= BANG_OLUFSEN_R_PAUSE_LEN_MAX)
                                 {
 #ifdef ANALYZE
                                     ANALYZE_PUTCHAR (last_value + '0');
                                     ANALYZE_NEWLINE ();
 #endif // ANALYZE
                                     irmp_store_bit (last_value);
-                                    wait_for_space = 0;
+                                    ir->isr.wait_for_space = 0;
                                 }
                                 else
                                 {                                                   // timing incorrect!
 #ifdef ANALYZE
-                                    ANALYZE_PRINTF ("error 3c B&O: timing not correct: data bit %d,  pulse: %d, pause: %d\n", irmp_bit, irmp_pulse_time, irmp_pause_time);
+                                    ANALYZE_PRINTF ("error 3c B&O: timing not correct: data bit %d,  pulse: %d, pause: %d\n", ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
                                     ANALYZE_ONLY_NORMAL_PUTCHAR ('\n');
 #endif // ANALYZE
-                                    irmp_start_bit_detected = 0;                    // reset flags and wait for next start bit
-                                    irmp_pause_time         = 0;
+                                    ir->isr.start_bit_detected = 0;                    // reset flags and wait for next start bit
+                                    ir->isr.pause_time         = 0;
                                 }
                             }
                         }
                         else
                         {                                                           // timing incorrect!
 #ifdef ANALYZE
-                            ANALYZE_PRINTF ("error 3d B&O: timing not correct: data bit %d,  pulse: %d, pause: %d\n", irmp_bit, irmp_pulse_time, irmp_pause_time);
+                            ANALYZE_PRINTF ("error 3d B&O: timing not correct: data bit %d,  pulse: %d, pause: %d\n", ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
                             ANALYZE_ONLY_NORMAL_PUTCHAR ('\n');
 #endif // ANALYZE
-                            irmp_start_bit_detected = 0;                            // reset flags and wait for next start bit
-                            irmp_pause_time         = 0;
+                            ir->isr.start_bit_detected = 0;                            // reset flags and wait for next start bit
+                            ir->isr.pause_time         = 0;
                         }
                     }
                     else
 #endif // IRMP_SUPPORT_BANG_OLUFSEN_PROTOCOL
 
 #if IRMP_SUPPORT_RCMM_PROTOCOL == 1
-                    if (irmp_param.protocol == IRMP_RCMM32_PROTOCOL)
+                    if (ir->param.protocol == IRMP_RCMM32_PROTOCOL)
                     {
-                        if (irmp_pause_time >= RCMM32_BIT_00_PAUSE_LEN_MIN && irmp_pause_time <= RCMM32_BIT_00_PAUSE_LEN_MAX)
+                        if (ir->isr.pause_time >= RCMM32_BIT_00_PAUSE_LEN_MIN && ir->isr.pause_time <= RCMM32_BIT_00_PAUSE_LEN_MAX)
                         {
 #ifdef ANALYZE
                             ANALYZE_PUTCHAR ('0');
@@ -5034,7 +5061,7 @@ irmp_ISR (void)
                             irmp_store_bit (0);
                             irmp_store_bit (0);
                         }
-                        else if (irmp_pause_time >= RCMM32_BIT_01_PAUSE_LEN_MIN && irmp_pause_time <= RCMM32_BIT_01_PAUSE_LEN_MAX)
+                        else if (ir->isr.pause_time >= RCMM32_BIT_01_PAUSE_LEN_MIN && ir->isr.pause_time <= RCMM32_BIT_01_PAUSE_LEN_MAX)
                         {
 #ifdef ANALYZE
                             ANALYZE_PUTCHAR ('0');
@@ -5043,7 +5070,7 @@ irmp_ISR (void)
                             irmp_store_bit (0);
                             irmp_store_bit (1);
                         }
-                        else if (irmp_pause_time >= RCMM32_BIT_10_PAUSE_LEN_MIN && irmp_pause_time <= RCMM32_BIT_10_PAUSE_LEN_MAX)
+                        else if (ir->isr.pause_time >= RCMM32_BIT_10_PAUSE_LEN_MIN && ir->isr.pause_time <= RCMM32_BIT_10_PAUSE_LEN_MAX)
                         {
 #ifdef ANALYZE
                             ANALYZE_PUTCHAR ('1');
@@ -5052,7 +5079,7 @@ irmp_ISR (void)
                             irmp_store_bit (1);
                             irmp_store_bit (0);
                         }
-                        else if (irmp_pause_time >= RCMM32_BIT_11_PAUSE_LEN_MIN && irmp_pause_time <= RCMM32_BIT_11_PAUSE_LEN_MAX)
+                        else if (ir->isr.pause_time >= RCMM32_BIT_11_PAUSE_LEN_MIN && ir->isr.pause_time <= RCMM32_BIT_11_PAUSE_LEN_MAX)
                         {
 #ifdef ANALYZE
                             ANALYZE_PUTCHAR ('1');
@@ -5064,50 +5091,54 @@ irmp_ISR (void)
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("\n");
 #endif // ANALYZE
-                        wait_for_space = 0;
+                        ir->isr.wait_for_space = 0;
                     }
                     else
 #endif
 
-                    if (irmp_pulse_time >= irmp_param.pulse_1_len_min && irmp_pulse_time <= irmp_param.pulse_1_len_max &&
-                        irmp_pause_time >= irmp_param.pause_1_len_min && irmp_pause_time <= irmp_param.pause_1_len_max)
+                    if (ir->isr.pulse_time >= ir->param.pulse_1_len_min
+                        && ir->isr.pulse_time <= ir->param.pulse_1_len_max
+                        && ir->isr.pause_time >= ir->param.pause_1_len_min
+                        && ir->isr.pause_time <= ir->param.pause_1_len_max)
                     {                                                               // pulse & pause timings correct for "1"?
 #ifdef ANALYZE
                         ANALYZE_PUTCHAR ('1');
                         ANALYZE_NEWLINE ();
 #endif // ANALYZE
                         irmp_store_bit (1);
-                        wait_for_space = 0;
+                        ir->isr.wait_for_space = 0;
                     }
-                    else if (irmp_pulse_time >= irmp_param.pulse_0_len_min && irmp_pulse_time <= irmp_param.pulse_0_len_max &&
-                             irmp_pause_time >= irmp_param.pause_0_len_min && irmp_pause_time <= irmp_param.pause_0_len_max)
+                    else if (ir->isr.pulse_time >= ir->param.pulse_0_len_min
+                             && ir->isr.pulse_time <= ir->param.pulse_0_len_max
+                             && ir->isr.pause_time >= ir->param.pause_0_len_min
+                             && ir->isr.pause_time <= ir->param.pause_0_len_max)
                     {                                                               // pulse & pause timings correct for "0"?
 #ifdef ANALYZE
                         ANALYZE_PUTCHAR ('0');
                         ANALYZE_NEWLINE ();
 #endif // ANALYZE
                         irmp_store_bit (0);
-                        wait_for_space = 0;
+                        ir->isr.wait_for_space = 0;
                     }
                     else
 #if IRMP_SUPPORT_KATHREIN_PROTOCOL
 
-                    if (irmp_param.protocol == IRMP_KATHREIN_PROTOCOL &&
-                        irmp_pulse_time >= KATHREIN_1_PULSE_LEN_MIN && irmp_pulse_time <= KATHREIN_1_PULSE_LEN_MAX &&
-                        (((irmp_bit == 8 || irmp_bit == 6) &&
-                                irmp_pause_time >= KATHREIN_SYNC_BIT_PAUSE_LEN_MIN && irmp_pause_time <= KATHREIN_SYNC_BIT_PAUSE_LEN_MAX) ||
-                         (irmp_bit == 12 &&
-                                irmp_pause_time >= KATHREIN_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= KATHREIN_START_BIT_PAUSE_LEN_MAX)))
+                    if (ir->param.protocol == IRMP_KATHREIN_PROTOCOL &&
+                        ir->isr.pulse_time >= KATHREIN_1_PULSE_LEN_MIN && ir->isr.pulse_time <= KATHREIN_1_PULSE_LEN_MAX &&
+                        (((ir->bit == 8 || ir->bit == 6) &&
+                                ir->isr.pause_time >= KATHREIN_SYNC_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= KATHREIN_SYNC_BIT_PAUSE_LEN_MAX) ||
+                         (ir->bit == 12 &&
+                                ir->isr.pause_time >= KATHREIN_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= KATHREIN_START_BIT_PAUSE_LEN_MAX)))
 
                     {
-                        if (irmp_bit == 8)
+                        if (ir->bit == 8)
                         {
-                            irmp_bit++;
+                            ir->bit++;
 #ifdef ANALYZE
                             ANALYZE_PUTCHAR ('S');
                             ANALYZE_NEWLINE ();
 #endif // ANALYZE
-                            irmp_tmp_command <<= 1;
+                            ir->tmp_command <<= 1;
                         }
                         else
                         {
@@ -5117,41 +5148,41 @@ irmp_ISR (void)
 #endif // ANALYZE
                             irmp_store_bit (1);
                         }
-                        wait_for_space = 0;
+                        ir->isr.wait_for_space = 0;
                     }
                     else
 #endif // IRMP_SUPPORT_KATHREIN_PROTOCOL
                     {                                                               // timing incorrect!
 #ifdef ANALYZE
-                        ANALYZE_PRINTF ("error 3: timing not correct: data bit %d,  pulse: %d, pause: %d\n", irmp_bit, irmp_pulse_time, irmp_pause_time);
+                        ANALYZE_PRINTF ("error 3: timing not correct: data bit %d,  pulse: %d, pause: %d\n", ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
                         ANALYZE_ONLY_NORMAL_PUTCHAR ('\n');
 #endif // ANALYZE
-                        irmp_start_bit_detected = 0;                                // reset flags and wait for next start bit
-                        irmp_pause_time         = 0;
+                        ir->isr.start_bit_detected = 0;                                // reset flags and wait for next start bit
+                        ir->isr.pause_time         = 0;
                     }
 
-                    irmp_pulse_time = 1;                                            // set counter to 1, not 0
+                    ir->isr.pulse_time = 1;                                            // set counter to 1, not 0
                 }
             }
             else
             {                                                                       // counting the pulse length ...
                 if (! irmp_input)                                                   // still light?
                 {                                                                   // yes...
-                    irmp_pulse_time++;                                              // increment counter
+                    ir->isr.pulse_time++;                                              // increment counter
                 }
                 else
                 {                                                                   // now it's dark!
-                    wait_for_space  = 1;                                            // let's count the time (see above)
-                    irmp_pause_time = 1;                                            // set pause counter to 1, not 0
+                    ir->isr.wait_for_space  = 1;                                            // let's count the time (see above)
+                    ir->isr.pause_time = 1;                                            // set pause counter to 1, not 0
 
 #if IRMP_SUPPORT_RCII_PROTOCOL == 1
-                    if (irmp_param.protocol == IRMP_RCII_PROTOCOL && waiting_for_2nd_pulse)
+                    if (ir->param.protocol == IRMP_RCII_PROTOCOL && waiting_for_2nd_pulse)
                     {
-printf ("fm: %d %d\n", irmp_pulse_time * 1000000 / F_INTERRUPTS, RCII_BIT_LEN * 1000000 / F_INTERRUPTS); // fm: Ausgabe ist "1000 466" oder "1533 466"
+printf ("fm: %d %d\n", ir->isr.pulse_time * 1000000 / F_INTERRUPTS, RCII_BIT_LEN * 1000000 / F_INTERRUPTS); // fm: Ausgabe ist "1000 466" oder "1533 466"
 #if 0
-                        if (irmp_pulse_time >= RCII_BIT_LEN)
+                        if (ir->isr.pulse_time >= RCII_BIT_LEN)
                         {
-                            irmp_pulse_time -= RCII_BIT_LEN;
+                            ir->isr.pulse_time -= RCII_BIT_LEN;
                             last_value = 0;
                         }
                         else
@@ -5159,12 +5190,12 @@ printf ("fm: %d %d\n", irmp_pulse_time *
                             last_value = 1;
                         }
 #else // fm: das reicht für RCII
-                            irmp_pulse_time -= RCII_BIT_LEN;
+                            ir->isr.pulse_time -= RCII_BIT_LEN;
                             last_value = 0;
 #endif
 
 #ifdef ANALYZE
-                        ANALYZE_PRINTF ("RCII: got 2nd pulse, irmp_pulse_time = %d\n", irmp_pulse_time);
+                        ANALYZE_PRINTF ("RCII: got 2nd pulse, ir->isr.pulse_time = %d\n", ir->isr.pulse_time);
 #endif
                         waiting_for_2nd_pulse = 0;
                     }
@@ -5172,123 +5203,123 @@ printf ("fm: %d %d\n", irmp_pulse_time *
                 }
             }
 
-            if (irmp_start_bit_detected && irmp_bit == irmp_param.complete_len && irmp_param.stop_bit == 0)    // enough bits received?
+            if (ir->isr.start_bit_detected && ir->bit == ir->param.complete_len && ir->param.stop_bit == 0)    // enough bits received?
             {
-                if (last_irmp_command == irmp_tmp_command && key_repetition_len < AUTO_FRAME_REPETITION_LEN)
+                if (last_irmp_command == ir->tmp_command && ir->isr.key_repetition_len < AUTO_FRAME_REPETITION_LEN)
                 {
-                    repetition_frame_number++;
+                    ir->isr.repetition_frame_number++;
                 }
                 else
                 {
-                    repetition_frame_number = 0;
+                    ir->isr.repetition_frame_number = 0;
                 }
 
 #if IRMP_SUPPORT_SIRCS_PROTOCOL == 1
                 // if SIRCS protocol and the code will be repeated within 50 ms, we will ignore 2nd and 3rd repetition frame
-                if (irmp_param.protocol == IRMP_SIRCS_PROTOCOL && (repetition_frame_number == 1 || repetition_frame_number == 2))
+                if (ir->param.protocol == IRMP_SIRCS_PROTOCOL && (ir->isr.repetition_frame_number == 1 || ir->isr.repetition_frame_number == 2))
                 {
 #ifdef ANALYZE
                     ANALYZE_PRINTF ("code skipped: SIRCS auto repetition frame #%d, counter = %d, auto repetition len = %d\n",
-                                    repetition_frame_number + 1, key_repetition_len, AUTO_FRAME_REPETITION_LEN);
+                                    ir->isr.repetition_frame_number + 1, ir->isr.key_repetition_len, AUTO_FRAME_REPETITION_LEN);
 #endif // ANALYZE
-                    key_repetition_len = 0;
+                    ir->isr.key_repetition_len = 0;
                 }
                 else
 #endif
 
 #if IRMP_SUPPORT_ORTEK_PROTOCOL == 1
                 // if ORTEK protocol and the code will be repeated within 50 ms, we will ignore 2nd repetition frame
-                if (irmp_param.protocol == IRMP_ORTEK_PROTOCOL && repetition_frame_number == 1)
+                if (ir->param.protocol == IRMP_ORTEK_PROTOCOL && ir->isr.repetition_frame_number == 1)
                 {
 #ifdef ANALYZE
                     ANALYZE_PRINTF ("code skipped: ORTEK auto repetition frame #%d, counter = %d, auto repetition len = %d\n",
-                                    repetition_frame_number + 1, key_repetition_len, AUTO_FRAME_REPETITION_LEN);
+                                    ir->isr.repetition_frame_number + 1, ir->isr.key_repetition_len, AUTO_FRAME_REPETITION_LEN);
 #endif // ANALYZE
-                    key_repetition_len = 0;
+                    ir->isr.key_repetition_len = 0;
                 }
                 else
 #endif
 
 #if 0 && IRMP_SUPPORT_KASEIKYO_PROTOCOL == 1    // fm 2015-12-02: don't ignore every 2nd frame
                 // if KASEIKYO protocol and the code will be repeated within 50 ms, we will ignore 2nd repetition frame
-                if (irmp_param.protocol == IRMP_KASEIKYO_PROTOCOL && repetition_frame_number == 1)
+                if (ir->param.protocol == IRMP_KASEIKYO_PROTOCOL && ir->isr.repetition_frame_number == 1)
                 {
 #ifdef ANALYZE
                     ANALYZE_PRINTF ("code skipped: KASEIKYO auto repetition frame #%d, counter = %d, auto repetition len = %d\n",
-                                    repetition_frame_number + 1, key_repetition_len, AUTO_FRAME_REPETITION_LEN);
+                                    ir->isr.repetition_frame_number + 1, ir->isr.key_repetition_len, AUTO_FRAME_REPETITION_LEN);
 #endif // ANALYZE
-                    key_repetition_len = 0;
+                    ir->isr.key_repetition_len = 0;
                 }
                 else
 #endif
 
 #if 0 && IRMP_SUPPORT_SAMSUNG_PROTOCOL == 1     // fm 2015-12-02: don't ignore every 2nd frame
                 // if SAMSUNG32 or SAMSUNG48 protocol and the code will be repeated within 50 ms, we will ignore every 2nd frame
-                if ((irmp_param.protocol == IRMP_SAMSUNG32_PROTOCOL || irmp_param.protocol == IRMP_SAMSUNG48_PROTOCOL) && (repetition_frame_number & 0x01))
+                if ((ir->param.protocol == IRMP_SAMSUNG32_PROTOCOL || ir->param.protocol == IRMP_SAMSUNG48_PROTOCOL) && (ir->isr.repetition_frame_number & 0x01))
                 {
 #ifdef ANALYZE
                     ANALYZE_PRINTF ("code skipped: SAMSUNG32/SAMSUNG48 auto repetition frame #%d, counter = %d, auto repetition len = %d\n",
-                                    repetition_frame_number + 1, key_repetition_len, AUTO_FRAME_REPETITION_LEN);
+                                    ir->isr.repetition_frame_number + 1, ir->isr.key_repetition_len, AUTO_FRAME_REPETITION_LEN);
 #endif // ANALYZE
-                    key_repetition_len = 0;
+                    ir->isr.key_repetition_len = 0;
                 }
                 else
 #endif
 
 #if IRMP_SUPPORT_NUBERT_PROTOCOL == 1
                 // if NUBERT protocol and the code will be repeated within 50 ms, we will ignore every 2nd frame
-                if (irmp_param.protocol == IRMP_NUBERT_PROTOCOL && (repetition_frame_number & 0x01))
+                if (ir->param.protocol == IRMP_NUBERT_PROTOCOL && (ir->isr.repetition_frame_number & 0x01))
                 {
 #ifdef ANALYZE
                     ANALYZE_PRINTF ("code skipped: NUBERT auto repetition frame #%d, counter = %d, auto repetition len = %d\n",
-                                    repetition_frame_number + 1, key_repetition_len, AUTO_FRAME_REPETITION_LEN);
+                                    ir->isr.repetition_frame_number + 1, ir->isr.key_repetition_len, AUTO_FRAME_REPETITION_LEN);
 #endif // ANALYZE
-                    key_repetition_len = 0;
+                    ir->isr.key_repetition_len = 0;
                 }
                 else
 #endif
 
 #if IRMP_SUPPORT_SPEAKER_PROTOCOL == 1
                 // if SPEAKER protocol and the code will be repeated within 50 ms, we will ignore every 2nd frame
-                if (irmp_param.protocol == IRMP_SPEAKER_PROTOCOL && (repetition_frame_number & 0x01))
+                if (ir->param.protocol == IRMP_SPEAKER_PROTOCOL && (ir->isr.repetition_frame_number & 0x01))
                 {
 #ifdef ANALYZE
                     ANALYZE_PRINTF ("code skipped: SPEAKER auto repetition frame #%d, counter = %d, auto repetition len = %d\n",
-                                    repetition_frame_number + 1, key_repetition_len, AUTO_FRAME_REPETITION_LEN);
+                                    ir->isr.repetition_frame_number + 1, ir->isr.key_repetition_len, AUTO_FRAME_REPETITION_LEN);
 #endif // ANALYZE
-                    key_repetition_len = 0;
+                    ir->isr.key_repetition_len = 0;
                 }
                 else
 #endif
 
                 {
 #ifdef ANALYZE
-                    ANALYZE_PRINTF ("%8.3fms code detected, length = %d\n", (double) (time_counter * 1000) / F_INTERRUPTS, irmp_bit);
+                    ANALYZE_PRINTF ("%8.3fms code detected, length = %d\n", (double) (time_counter * 1000) / F_INTERRUPTS, ir->bit);
 #endif // ANALYZE
-                    irmp_ir_detected = TRUE;
+                    ir->ir_detected = TRUE;
 
 #if IRMP_SUPPORT_DENON_PROTOCOL == 1
-                    if (irmp_param.protocol == IRMP_DENON_PROTOCOL)
+                    if (ir->param.protocol == IRMP_DENON_PROTOCOL)
                     {                                                               // check for repetition frame
-                        if ((~irmp_tmp_command & 0x3FF) == last_irmp_denon_command) // command bits must be inverted
+                        if ((~ir->tmp_command & 0x3FF) == last_irmp_denon_command) // command bits must be inverted
                         {
-                            irmp_tmp_command = last_irmp_denon_command;             // use command received before!
+                            ir->tmp_command = last_irmp_denon_command;             // use command received before!
                             last_irmp_denon_command = 0;
 
-                            irmp_protocol = irmp_param.protocol;                    // store protocol
-                            irmp_address = irmp_tmp_address;                        // store address
-                            irmp_command = irmp_tmp_command;                        // store command
+                            ir->protocol = ir->param.protocol;                    // store protocol
+                            ir->address = ir->tmp_address;                        // store address
+                            ir->command = ir->tmp_command;                        // store command
                         }
                         else
                         {
-                            if ((irmp_tmp_command & 0x01) == 0x00)
+                            if ((ir->tmp_command & 0x01) == 0x00)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("%8.3fms info Denon: waiting for inverted command repetition\n", (double) (time_counter * 1000) / F_INTERRUPTS);
 #endif // ANALYZE
-                                last_irmp_denon_command = irmp_tmp_command;
+                                last_irmp_denon_command = ir->tmp_command;
                                 denon_repetition_len = 0;
-                                irmp_ir_detected = FALSE;
+                                ir->ir_detected = FALSE;
                             }
                             else
                             {
@@ -5296,7 +5327,7 @@ printf ("fm: %d %d\n", irmp_pulse_time *
                                 ANALYZE_PRINTF ("%8.3fms warning Denon: got unexpected inverted command, ignoring it\n", (double) (time_counter * 1000) / F_INTERRUPTS);
 #endif // ANALYZE
                                 last_irmp_denon_command = 0;
-                                irmp_ir_detected = FALSE;
+                                ir->ir_detected = FALSE;
                             }
                         }
                     }
@@ -5304,54 +5335,54 @@ printf ("fm: %d %d\n", irmp_pulse_time *
 #endif // IRMP_SUPPORT_DENON_PROTOCOL
 
 #if IRMP_SUPPORT_GRUNDIG_PROTOCOL == 1
-                    if (irmp_param.protocol == IRMP_GRUNDIG_PROTOCOL && irmp_tmp_command == 0x01ff)
+                    if (ir->param.protocol == IRMP_GRUNDIG_PROTOCOL && ir->tmp_command == 0x01ff)
                     {                                                               // Grundig start frame?
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("Detected GRUNDIG start frame, ignoring it\n");
 #endif // ANALYZE
-                        irmp_ir_detected = FALSE;
+                        ir->ir_detected = FALSE;
                     }
                     else
 #endif // IRMP_SUPPORT_GRUNDIG_PROTOCOL
 
 #if IRMP_SUPPORT_NOKIA_PROTOCOL == 1
-                    if (irmp_param.protocol == IRMP_NOKIA_PROTOCOL && irmp_tmp_address == 0x00ff && irmp_tmp_command == 0x00fe)
+                    if (ir->param.protocol == IRMP_NOKIA_PROTOCOL && ir->tmp_address == 0x00ff && ir->tmp_command == 0x00fe)
                     {                                                               // Nokia start frame?
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("Detected NOKIA start frame, ignoring it\n");
 #endif // ANALYZE
-                        irmp_ir_detected = FALSE;
+                        ir->ir_detected = FALSE;
                     }
                     else
 #endif // IRMP_SUPPORT_NOKIA_PROTOCOL
                     {
 #if IRMP_SUPPORT_NEC_PROTOCOL == 1
-                        if (irmp_param.protocol == IRMP_NEC_PROTOCOL && irmp_bit == 0)  // repetition frame
+                        if (ir->param.protocol == IRMP_NEC_PROTOCOL && ir->bit == 0)  // repetition frame
                         {
-                            if (key_repetition_len < NEC_FRAME_REPEAT_PAUSE_LEN_MAX)
+                            if (ir->isr.key_repetition_len < NEC_FRAME_REPEAT_PAUSE_LEN_MAX)
                             {
 #ifdef ANALYZE
-                                ANALYZE_PRINTF ("Detected NEC repetition frame, key_repetition_len = %d\n", key_repetition_len);
+                                ANALYZE_PRINTF ("Detected NEC repetition frame, ir->isr.key_repetition_len = %d\n", ir->isr.key_repetition_len);
                                 ANALYZE_ONLY_NORMAL_PRINTF("REPETETION FRAME                ");
 #endif // ANALYZE
-                                irmp_tmp_address = last_irmp_address;                   // address is last address
-                                irmp_tmp_command = last_irmp_command;                   // command is last command
-                                irmp_flags |= IRMP_FLAG_REPETITION;
-                                key_repetition_len = 0;
+                                ir->tmp_address = last_irmp_address;                   // address is last address
+                                ir->tmp_command = last_irmp_command;                   // command is last command
+                                ir->flags |= IRMP_FLAG_REPETITION;
+                                ir->isr.key_repetition_len = 0;
                             }
                             else
                             {
 #ifdef ANALYZE
-                                ANALYZE_PRINTF ("Detected NEC repetition frame, ignoring it: timeout occured, key_repetition_len = %d > %d\n",
-                                                key_repetition_len, NEC_FRAME_REPEAT_PAUSE_LEN_MAX);
+                                ANALYZE_PRINTF ("Detected NEC repetition frame, ignoring it: timeout occured, ir->isr.key_repetition_len = %d > %d\n",
+                                                ir->isr.key_repetition_len, NEC_FRAME_REPEAT_PAUSE_LEN_MAX);
 #endif // ANALYZE
-                                irmp_ir_detected = FALSE;
+                                ir->ir_detected = FALSE;
                             }
                         }
 #endif // IRMP_SUPPORT_NEC_PROTOCOL
 
 #if IRMP_SUPPORT_KASEIKYO_PROTOCOL == 1
-                        if (irmp_param.protocol == IRMP_KASEIKYO_PROTOCOL)
+                        if (ir->param.protocol == IRMP_KASEIKYO_PROTOCOL)
                         {
                             uint_fast8_t xor_value;
 
@@ -5362,7 +5393,7 @@ printf ("fm: %d %d\n", irmp_pulse_time *
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("error 4: wrong XOR check for customer id: 0x%1x 0x%1x\n", xor_value, xor_check[2] & 0x0F);
 #endif // ANALYZE
-                                irmp_ir_detected = FALSE;
+                                ir->ir_detected = FALSE;
                             }
 
                             xor_value = xor_check[2] ^ xor_check[3] ^ xor_check[4];
@@ -5372,42 +5403,42 @@ printf ("fm: %d %d\n", irmp_pulse_time *
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("error 5: wrong XOR check for data bits: 0x%02x 0x%02x\n", xor_value, xor_check[5]);
 #endif // ANALYZE
-                                irmp_ir_detected = FALSE;
+                                ir->ir_detected = FALSE;
                             }
 
-                            irmp_flags |= genre2;       // write the genre2 bits into MSB of the flag byte
+                            ir->flags |= genre2;       // write the genre2 bits into MSB of the flag byte
                         }
 #endif // IRMP_SUPPORT_KASEIKYO_PROTOCOL == 1
 
 #if IRMP_SUPPORT_ORTEK_PROTOCOL == 1
-                        if (irmp_param.protocol == IRMP_ORTEK_PROTOCOL)
+                        if (ir->param.protocol == IRMP_ORTEK_PROTOCOL)
                         {
                             if (parity == PARITY_CHECK_FAILED)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("error 6: parity check failed\n");
 #endif // ANALYZE
-                                irmp_ir_detected = FALSE;
+                                ir->ir_detected = FALSE;
                             }
 
-                            if ((irmp_tmp_address & 0x03) == 0x02)
+                            if ((ir->tmp_address & 0x03) == 0x02)
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("code skipped: ORTEK end of transmission frame (key release)\n");
 #endif // ANALYZE
-                                irmp_ir_detected = FALSE;
+                                ir->ir_detected = FALSE;
                             }
-                            irmp_tmp_address >>= 2;
+                            ir->tmp_address >>= 2;
                         }
 #endif // IRMP_SUPPORT_ORTEK_PROTOCOL == 1
 
 #if IRMP_SUPPORT_MITSU_HEAVY_PROTOCOL == 1
-                        if (irmp_param.protocol == IRMP_MITSU_HEAVY_PROTOCOL)
+                        if (ir->param.protocol == IRMP_MITSU_HEAVY_PROTOCOL)
                         {
-                            check = irmp_tmp_command >> 8;                    // inverted upper byte == lower byte?
+                            check = ir->tmp_command >> 8;                    // inverted upper byte == lower byte?
                             check = ~ check;
-                            if (check == (irmp_tmp_command & 0xFF)) {         //ok:
-                              irmp_tmp_command &= 0xFF;
+                            if (check == (ir->tmp_command & 0xFF)) {         //ok:
+                              ir->tmp_command &= 0xFF;
                             }
                             else  mitsu_parity = PARITY_CHECK_FAILED;
                             if (mitsu_parity == PARITY_CHECK_FAILED)
